unit AllocTypes;


interface


uses


Windows;


type


UInt64                              = Int64;//for now, since it is not defined.


//Pointers
TPShortInt                          = ^ShortInt;
TPByte                              = ^Byte;
TPSmallInt                          = ^SmallInt;
TPWord                              = ^Word;
TPLongWord                          = ^LongWord;
TPLongInt                           = ^LongInt;
TPInteger                           = ^Integer;
TPInt64                             = ^Int64;
TPLongBool                          = ^LongBool;
TPSingle                            = ^Single;
TPDouble                            = ^Double;
TPExtended                          = ^Extended;

TPVariant                           = ^Variant;


//Arrays
TAByte                              = Array[0..(MaxInt div (SizeOf(Byte)*2))] of Byte;
TPAByte                             = ^TAByte;
TMByte                              =  Array[0..(MaxInt div (SizeOf(TPAByte)*2))] of TPAByte;
TPMByte                             = ^TMByte;

TAShort                             = Array[0..(MaxInt div (SizeOf(ShortInt)*2))] of ShortInt;
TPAShort                            = ^TAShort;
TMShort                             =  Array[0..(MaxInt div (SizeOf(TPAShort)*2))] of TPAShort;
TPMShort                            = ^TMShort;

TASmall                             = Array[0..(MaxInt div (SizeOf(SmallInt)*2))] of SmallInt;
TPASmall                            = ^TASmall;
TMSmall                             =  Array[0..(MaxInt div (SizeOf(TPASmall)*2))] of TPASmall;
TPMSmall                            = ^TMSmall;

TAWord                              = Array[0..(MaxInt div (SizeOf(Word)*2))] of Word;
TPAWord                             = ^TAWord;
TMWord                              =  Array[0..(MaxInt div (SizeOf(TPAWord)*2))] of TPAWord;
TPMWord                             = ^TMWord;

TALongWord                          = Array[0..(MaxInt div (SizeOf(LongWord)*2))] of LongWord;
TPALongWord                         = ^TALongWord;
TMLongWord                          =  Array[0..(MaxInt div (SizeOf(TPALongWord)*2))] of TPALongWord;
TPMLongWord                         = ^TMLongWord;

TASmallInt                          = Array[0..(MaxInt div (SizeOf(SmallInt)*2))] of SmallInt;
TPASmallInt                         = ^TASmallInt;
TMSmallInt                          =  Array[0..(MaxInt div (SizeOf(TPASmallInt)*2))] of TPASmallInt;
TPMSmallInt                         = ^TMSmallInt;

TALongInt                           = Array[0..(MaxInt div (SizeOf(LongInt)*2))] of LongInt;
TPALongInt                          = ^TALongInt;
TMLongInt                           =  Array[0..(MaxInt div (SizeOf(TPALongInt)*2))] of TPALongInt;
TPMLongInt                          = ^TMLongInt;

TAInteger                           = Array[0..(MaxInt div (SizeOf(Integer)*2))] of Integer;
TPAInteger                          = ^TAInteger;
TMInteger                           =  Array[0..(MaxInt div (SizeOf(TPAInteger)*2))] of TPAInteger;
TPMInteger                          = ^TMInteger;

TAInt64                             = Array[0..(MaxInt div (SizeOf(Int64)*2))] of Int64;
TPAInt64                            = ^TAInt64;
TMInt64                             =  Array[0..(MaxInt div (SizeOf(TPAInt64)*2))] of TPAInt64;
TPMInt64                            = ^TMInt64;

TAUInt64                            = Array[0..(MaxInt div (SizeOf(UInt64)*2))] of UInt64;
TPAUInt64                           = ^TAUInt64;
TMUInt64                            =  Array[0..(MaxInt div (SizeOf(TPAUInt64)*2))] of TPAUInt64;
TPMUInt64                           = ^TMUInt64;

TABoolean                           = Array[0..(MaxInt div (SizeOf(Boolean)*2))] of Boolean;
TPABoolean                          = ^TABoolean;
TMBoolean                           =  Array[0..(MaxInt div (SizeOf(TPABoolean)*2))] of TPABoolean;
TPMBoolean                          = ^TMBoolean;

TACardinal                          = Array[0..(MaxInt div (SizeOf(Cardinal)*2))] of Cardinal;
TPACardinal                         = ^TACardinal;
TMCardinal                          =  Array[0..(MaxInt div (SizeOf(TPACardinal)*2))] of TPACardinal;
TPMCardinal                         = ^TMCardinal;

TASingle                            = Array[0..(MaxInt div (SizeOf(Single)*2))] of Single;
TPASingle                           = ^TASingle;
TMSingle                            =  Array[0..(MaxInt div (SizeOf(TPASingle)*2))] of TPASingle;
TPMSingle                           = ^TMSingle;

TADouble                            = Array[0..(MaxInt div (SizeOf(Double)*2))] of Double;
TPADouble                           = ^TADouble;
TMDouble                            =  Array[0..(MaxInt div (SizeOf(TPADouble)*2))] of TPADouble;
TPMDouble                           = ^TMDouble;

TAExtended                          = Array[0..(MaxInt div (SizeOf(Extended)*2))] of Extended;
TPAExtended                         = ^TAExtended;
TMExtended                          =  Array[0..(MaxInt div (SizeOf(TPAExtended)*2))] of TPAExtended;
TPMExtended                         = ^TMExtended;

TPAChar                             = PChar;
TMChar                              =  Array[0..(MaxInt div (SizeOf(TPAChar)*2))] of TPAChar;
TPMChar                             = ^TMChar;

TAPoint                             = Array[0..(MaxInt div (SizeOf(TPoint)*2))] of TPoint;
TPAPoint                            = ^TAPoint;
TMPoint                             =  Array[0..(MaxInt div (SizeOf(TPAPoint)*2))] of TPAPoint;
TPMPoint                            = ^TMPoint;

TAPointer                           = Array[0..(MaxInt div (SizeOf(Pointer)*2))] of Pointer;
TPAPointer                          = ^TAPointer;
TMPointer                           =  Array[0..(MaxInt div (SizeOf(TPAPointer)*2))] of TPAPointer;
TPMPointer                          = ^TMPointer;

TThreeBytes                         = Array[1..3] of Byte;
TAThreeBytes                        = Array[0..(MaxInt div (SizeOf(TThreeBytes)*2))] of TThreeBytes;
TPAThreeBytes                       = ^TAThreeBytes;
TMThreeBytes                        =  Array[0..(MaxInt div (SizeOf(TPAThreeBytes)*2))] of TPAThreeBytes;
TPMThreeBytes                       = ^TMThreeBytes;

ArrayOfInteger                      = Array of Integer;


implementation

end.
